/*->c.err */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"

#include "trans.h"
#include "etc.h"

#include "err.h"


static os_error   errblock;
static errlink  * firstlink;

#define LOCALERROR 0x0       // used to prevent error numbers going back to OS
                             // don't use here will upset things


os_error * adderrortable(errtag * tags,errlink * link)
{
 link->tags=tags;
 link->next=firstlink;
 firstlink=link;

 return(NULL);
}


static char * xerrmsg(int xerrno)
{
 errlink  * link;
 errtag   * tag;

 link=firstlink;

 while(link)
 {
  tag=link->tags;
  while(tag->xerrno!=ELAST)
  {
   if(tag->xerrno==xerrno)
   {
    return(tag->errmsg);
   }
   tag++;
  }
  link=link->next;
 }

 return("{ENOE}");
}


os_error * geterror(int xerrno)
{
 os_error * err;

 if(!xerrno) return(NULL);

 errblock.errnum=xerrno;
 strcpy(errblock.errmess,xerrmsg(xerrno));
 err=trans(errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR));
 if(!err) err=&errblock;
 return(err);
}


os_error * geterrorf(int xerrno,...)
{
 va_list    args;
 char       format[256];
 os_error * err;
 int        len;

 errblock.errnum=xerrno;
 strcpy(format,xerrmsg(xerrno));
 trans(format,sizeof(format)/sizeof(TCHAR));

 va_start(args,xerrno);
 VSNPRINTF(errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR),format,args,len);
 va_end(args);

 err=trans(errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR));
 if(!err) err=&errblock;
 return(err);
}


os_error * generror(int xerrno,char * format, ...)
{
 va_list    args;
 os_error * err;
 char       format2[256];
 int        len;

	strcpy(format2,format);

 trans(format2,sizeof(format2)/sizeof(TCHAR));
 errblock.errnum=xerrno;

 va_start(args,format);
 VSNPRINTF(errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR),format2,args,len);
 va_end(args);

 err=trans(errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR));
 if(!err) err=&errblock;

 return(err);
}


os_error * erroradd(os_error * err1,os_error * err2)
{
 if(err1) return(err1);
 else     return(err2);
}


os_error * initerror(void)
{
 firstlink=NULL;
 return(NULL);
}


