/*->h.fsx */


#define FSMAXLEAF 256
#define FSMAXPATH 1024
#define FSMAXEXTLEN 64

typedef struct fstat
{
  int  object;
  int  length;
  int  load;
  int  exec;
  int  acc;
  int  type;
} fstat;



typedef struct fxstat
{
 fstat f;
 TCHAR name[FSMAXLEAF];
} fxstat;


typedef void * fsscanhandle;



#define CODE -1
#define APP   0x2000
#define DIR   0x1000

extern os_error * fs_expandpath(TCHAR * src,TCHAR * dest,int size);

extern os_error * fs_eof(fshandle fh,int * eof);
extern os_error * fs_tell(fshandle fh,int * posn);
extern os_error * fs_open(TCHAR * name,int mode,fshandle * fh);
extern os_error * fs_close(fshandle fh,os_error * ep);
extern os_error * fs_readat(fshandle fh,void * b,int n,int at);
extern os_error * fs_readn(fshandle fh,void * b,int n,int * read);
extern os_error * fs_read(fshandle fh,void * b,int n);
extern os_error * fs_getc(fshandle fh,int * c);
extern os_error * fs_writen(fshandle fh,void * b,int n,int * write);
extern os_error * fs_write(fshandle fh,void * b,int n);
extern os_error * fs_writeat(fshandle fh,void * b,int n,int at);
extern os_error * fs_seek(fshandle fh,int posn);
extern os_error * fs_setfileextent(fshandle fh,int ex);
extern os_error * fs_saveblock(TCHAR *name,int type,void * start,int len);
extern os_error * fs_loadblock(TCHAR *name,void * start);
extern os_error * fs_alloc(TCHAR * name,unsigned char ** alloc,unsigned int * length);
extern os_error * fs_delete(TCHAR * name);
extern os_error * fs_rename(TCHAR * oldname,TCHAR * newname);
extern void       fs_startscan(void);
extern void       fs_savescan(fsscanhandle * save);
extern void       fs_loadscan(fsscanhandle save);
extern os_error * fs_endscan(void);
extern os_error * fs_nextitem(TCHAR * dirname,fxstat * f,TCHAR * wild,int * eof);

extern TCHAR    * fs_leaf(TCHAR * filename);
extern os_error * fs_path(TCHAR * filename,TCHAR * path,int maxlen);
extern int        fs_filetype(int load);
extern os_error * fs_stat(TCHAR * name,fstat * f);
extern os_error * fs_stat2(TCHAR * name,fstat * f);
extern os_error * fs_stamp(TCHAR * name,fstat * f);
extern os_error * fs_exists(TCHAR * name,int * type);
extern os_error * fs_exists2(TCHAR * name,int * type);
extern os_error * fs_create(TCHAR * name,int length,int type);
extern os_error * fs_cdir(TCHAR * name);
extern    TCHAR * fs_typestring(int type);
extern os_error * fs_canonicalpath(TCHAR * path,TCHAR * buffer,int len,
                                      TCHAR * pathvar,TCHAR * pathstring);

extern os_error * fs_isrelativepath(TCHAR * path,int * relative);
extern os_error * fs_combinepath(TCHAR * newpath,TCHAR * dirpath,TCHAR * filepath);


extern os_error * fs_settype(TCHAR * filename,int type);

extern TCHAR * fs_extension(TCHAR * name);
extern int    fs_filetypefromextension(TCHAR * name);
extern int    fs_filetypefromextensionx(TCHAR * name);
extern int    fs_extensionis(TCHAR * name,TCHAR * ext);
extern void   fs_checkextension(TCHAR * name,TCHAR * ext);
extern os_error * fs_strcat(TCHAR * path,int maxlen,TCHAR * filename);
extern os_error * fs_join(TCHAR * buffer,int maxlen,TCHAR * path,TCHAR * filename);
extern TCHAR * fs_addtoname(TCHAR * name,TCHAR * extra);
extern TCHAR * fs_newextension(TCHAR * name,TCHAR * ext);

extern int    fs_hidden(int acc);
extern int    fs_system(int acc);
extern int    fs_readonly(int acc);


extern int        fs_timecmp(fstat * f0,fstat * f1,int res);
//extern os_error * fs_newest(char * name[],int object,char ** newest,fstat * f);
extern os_error * fs_pair(TCHAR * name0,TCHAR * name1,int object,TCHAR ** newest,fstat * f);




/* c.fsx2 */


extern os_error * makefilename(TCHAR * oldleaf,TCHAR * newpathname,TCHAR * path,int over);

#define FS_MOVE 0x1

extern os_error * fs_copyobject(TCHAR * from,TCHAR * to,int flags,TCHAR * spare1,TCHAR * spare2);

extern os_error * fs_wipe(TCHAR * name);

extern os_error * fs_validatepath(TCHAR * to,int directory);

extern os_error * fs_copyfile(TCHAR * from,TCHAR * to);


extern void fs_scanstats(void);


extern os_error * fs_identify(int * filetype,TCHAR * name);
