// osglue.cpp

#include <stdafx.h>

#include <stdlib.h>

#include "os.h"
#include "wimp.h"
#include "transform.h"

#include "fsx.h"

#include "deb.h"
#include "etc.h"
#include "colour.h"
#include "wos.h"
#include "osgraphics.h"
#include "xprocess.h"
#include "ossprite.h"
#include "osglue.h"
#include "osunits.h"




HINSTANCE AppInstance;
TCHAR *   szAppName;
int       AppCmdShow;






extern "C" int		__argc;
extern "C" char**	__argv;


extern int main(int argc,char * argv[]);

#define CMDMAXARGS 16
#define CMDSIZE    1024





//#define SPI_GETWHEELSCROLLLINES   104
//#define SPI_SETWHEELSCROLLLINES   105

#define SPI_GETWHEELSCROLLCHARS                   0x006C
#define SPI_SETWHEELSCROLLCHARS                   0x006D
#define DEFAULT_CHARS_TO_SCROLL_WITH_EMULATION    0x01

// Default values for SPI_GETWHEELSCROLLLINES and 
// SPI_GETWHEELSCROLLCHARS
#define DEFAULT_LINES_TO_SCROLL                   0x03
#define DEFAULT_CHARS_TO_SCROLL                   0x03

// Cache the SPI_GETWHEELSCROLLLINES and SPI_GETWHEELSCROLLCHARS 
// settings


static UINT linesToScrollUserSetting;
static UINT charsToScrollUserSetting;


int deltaperline=40;




static UINT GetLinesToScrollUserSetting(void)
{
 UINT userSetting;
 
 // Retrieve the lines-to-scroll user setting. 
 BOOL success=SystemParametersInfo(SPI_GETWHEELSCROLLLINES,0,&userSetting,0);

 // Use a default value if the API failed.
 if(success==FALSE)
 {
  userSetting=DEFAULT_LINES_TO_SCROLL;
 }

 return(userSetting);
}



static UINT GetCharsToScrollUserSetting(void)
{
 UINT userSetting;

    // Retrieve the characters-to-scroll user setting. 
 BOOL success=SystemParametersInfo(SPI_GETWHEELSCROLLCHARS,0,&userSetting,0);

    // If SystemParametersInfo fails assign the correct value to 
    // user setting based on the OS version.
 if(success==FALSE)
 {
        // Get the OS version.
  OSVERSIONINFO version={ 0 };
  version.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
  GetVersionEx(&version);

  if(version.dwPlatformId==VER_PLATFORM_WIN32_NT && version.dwMajorVersion<6)
  {
            // On Windows 2000 and Windows XP set the value to 1 in 
            // order to work correctly with IntelliType Pro and 
            // IntelliPoint emulating the WM_MOUSEWHEEL message.
   userSetting=DEFAULT_CHARS_TO_SCROLL_WITH_EMULATION;
  }
  else
  {
            // On Longhorn and above use the default value of 3.
   userSetting=DEFAULT_CHARS_TO_SCROLL;
  }
 }

 return(userSetting);
}




int osgluechange(WPARAM wParam,LPARAM lParam)
{

 if(wParam==SPI_SETWHEELSCROLLLINES)
 {
  linesToScrollUserSetting=GetLinesToScrollUserSetting();
 }
 else
 if(wParam==SPI_SETWHEELSCROLLCHARS)
 {
  charsToScrollUserSetting=GetCharsToScrollUserSetting();
 }

 return(0);
}








int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

#ifdef NEVER
 int    argc;
 char * argv[CMDMAXARGS];
	char   cmd[CMDSIZE];
 char * p;
	char * s;
	char * e;
	int    inquotes;
#endif

 AppInstance=hInstance;
 AppCmdShow=nCmdShow;

#ifdef NEVER
 strcpy(cmd,GetCommandLine());

 argc=0;
 p=cmd;
	inquotes=0;

 while(1)
	{
  while(*p==' ') p++;
		if(*p==0) break;
		s=p;

		while(1)
		{
   if(*p=='\"')
			{
			 inquotes^=1;
   }

  	if((!inquotes && *p==' ') || *p==0)
  	{
    e=p;
    if(*p!=0) p++;

    if(*s=='\"') s++;
				if(e>s && *(e-1)=='\"') e--;
				*e=0;
	   argv[argc++]=s;

				break;
   }
   p++;
  }
 }

 szAppName=(argc>0)?fs_leaf(argv[0]):NULL;

 main(argc,argv);
#endif

 szAppName=(__argc>0)?fs_leaf(__argv[0]):NULL;

 main(__argc,__argv);

 return 0;


 USE(lpCmdLine);
 USE(hPrevInstance);
}
