/*->c.trans */

#include <stdafx.h>


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "wimp.h"

#include "flex.h"

#include "etc.h"
#include "fsx.h"
#include "bits.h"

#include "err.h"
#include "encrypt.h"

#include "deb.h"

#include "oserr.h"
#include "osglue.h"

#include "trans.h"




static char * text;
static int    size;

#ifdef NEVER

static void stripcrlf(char * d,char * s,unsigned int * length)
{
 char * slt;
 char * d1;
 int    c;
 int    lc;

 slt=s+(*length);
 d1=d;
 c=32;
 while(s<slt)
 {
  lc=c;
  c=*s++;
  if(!(c<32 && lc<32)) *d++=(char)c;
 }

 *length=d-d1;
}


#endif

static void stripcomments(char * d,char * s,unsigned int * length)
{
 char * slt;
 char * d1;
 int    c;
 int    lc;

 slt=s+(*length);
 d1=d;
 c=10;
 while(s<slt)
 {
  lc=c;
  c=*s++;

  if(lc<32 && c=='/' && s<slt && *s=='/')
  {
   while(s<slt)
   {
    c=*s++;
    if(c<32)
    {
     break;
    }
   }
   c=lc;
   continue;
  }

  if(!(c<32 && lc<32)) *d++=(char)c;
 }

 *length=d-d1;
}







/* merge in a new translation table */

os_error * addtranstable2a(char * path,char * leaf,ascaninstance instance)
{
 os_error * err;
 char       name[MAX_PATH];
 fstat      f;
 char     * p;
 char     * q=NULL;
 char     * r1;
 char     * r2;
 unsigned int length=0;
 HANDLE     hDialog=NULL; 
 HRSRC      hRsrc;


// cprintf("addtrans %s",leaf);

 if(path)
 {
  strcpy(name,path);
  strcat(name,"\\");
  strcat(name,leaf);

  err=fs_stat(name,&f);

cprintf("addtrans file %s",name);
  if(!err)
  {
   if(!f.object)
   {
    if(size) err=geterrorf(ENOTFOUND,name);
    else     err=generror(ENOTFOUND,"Messages file not found.");
   }
   else
   {
    err=flex_extend((flex_ptr)&text,size+f.length+2);
    if(!err)
    {
     p=text+size;
     err=fs_loadblock(name,p);
     length=f.length;
     stripcomments(p,p,&length);
    }
   }
  }
 }
 else
 {
  err=XFindResource((HINSTANCE)instance,leaf,"MESSAGES",&hRsrc);
  if(err)
  {
   err=NULL; // might be no messages
  }
  else
  {
   if(!err) err=XLoadResource((HINSTANCE)instance,hRsrc,(HGLOBAL*)&hDialog);
   if(!err) err=XLockResource(hDialog,(LPVOID*)&q);

   if(!err)
   {
             err=XSizeofResource((HINSTANCE)instance,hRsrc,&length);
    if(!err) err=flex_extend((flex_ptr)&text,size+length+2);
    if(!err)  // strip CRLF pairs
    {
     stripcomments(text+size,q,&length);
    }
   }
  }
 }



 if(!err)
 {
  p=text+size;

//  decryptresourceblock(p,&length); would be doomed if using \\ to mark eof

  *(p+length)=0;
  *(p+length+1)=0;

  r1=r2=q=p;

  while(1)
  {
   r1=p;
   while(*p && *p!=':') p++;
   *p++=0;
   if(!*p) break;
//   cprintf("%s",r1);
  
   r2=p;
   while(*p>=31) p++;
   *p++=0;
   if(!*p) break;
//   cprintf("%s",r2);
  }

  if((r2-r1)<2 || (p-r2)<2)
  {
   p=r1;
   *p=0;
  }

  size+=p-q;
 }

 return(err);
}



os_error * addtranstable(char * path,char * leaf)
{
 return(addtranstable2a(path,leaf,(ascaninstance)AppInstance));
}



char * transtoken(char * token)
{
 char * p;
 char * q;
 int    len;

// cprintf("transtoken %d %s",text,token);

 if(text)
 {
  p=text;

  while(1)
  {
   q=p;
   len=strlen(p);
   if(!len)
   {
    p=token;
    break;
   }
   p+=len+1;
//   cprintf("token %s %s",token,q);
   if(!strcmp(token,q)) break;
   len=strlen(p);
/*   if(!len)
   {
    p=token;
    break;
   }
*/
   p+=len+1;
  }
 } else p=token;

 return(p);
}


#define MAXTOKSIZE 32



/* translate the text in the buffer */

os_error * trans(char * buffer,int maxlen)
{
 char * p;
 char * q;
 char * limit;
 char * ps;
 char   token[MAXTOKSIZE];
 int    size;
 int    len;
 int    delta;



 p=buffer;
 size=strlen(buffer);
 limit=token+MAXTOKSIZE-1;

 while(*p)
 {
  if(*p++=='{')
  {
   if(!*p) break;
   else
   if(*p=='{')
   {
    memmove(p-1,p,size-(p-buffer)+1);
    size--;
    p++;
   }
   else  /* a token */
   {
    q=token;
    ps=p;
    while(*p && *p!='}' && q<limit) *q++=*p++;
    if(!*p || q>=limit)
    {
     p=ps;
    }
    else
    {
     *q=0;
     p++;
     q=transtoken(token);
     
     len=strlen(q);
     delta=len-(2+strlen(token));

     if((size+delta)<maxlen)
     {
      memmove(p+delta,p,size-(p-buffer)+1);
      p+=delta-len;
      size+=delta;
      XMEMCPYX(p,q,len);
     }
    }
   }
  }
 }

 return(NULL);
}


os_error * tsprintf(int maxlen,char * string,char * format, ...)
{
 os_error * err;
 va_list    args;
 char       buffer[1024];
 int        len;

 va_start(args,format);
          err=xzstrncpye(buffer,format,sizeof(buffer));
	if(!err) err=trans(buffer,sizeof(buffer));
 VSNPRINTF(string,maxlen,buffer,args,len);
 va_end(args);
 if(!err) err=trans(string,maxlen);

 return(err);
}


os_error * inittrans(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&text,0);
 size=0;

 return(err);
}



